
import jas.engine.*;
import jas.space.*;

import java.util.Random;
import java.awt.Point;

/**
 * The environment that the heat bugs inhabit. This uses a Diffuse2D to
 * diffuse the heat absorbed from the bugs.
 *
 * @author Swarm Project and Nick Collier
 * @version $Revision: 1.2 $ $Date: 2001/12/18 20:39:09 $
 */

public class HeatSpace extends DblDiffuseGrid {

  public static final int HOT = 0;
  public static final int COLD = 1;

  private long maxHeat = DblDiffuseGrid.MAX;
  private int[] xpoints = new int[9];
  private int[] ypoints = new int[9];

  public HeatSpace(double diffusionConstant, double evaporationRate,
                  int xSize, int ySize)
  {
    super(xSize, ySize, diffusionConstant, evaporationRate);
  }

  public void addHeat(int x, int y, int heat) {
    long heatHere = (long)this.getDbl(x, y);

    if (heatHere + heat <= maxHeat) {
      heatHere += heat;
    } else {
      heatHere = maxHeat;
    }

    this.setDbl(x, y, heatHere);
  }
}
